/*
**    TP CPE Lyon
**    Copyright (C) 2014 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "intersection_helper.hpp"
#include <cmath>
#include <vector>

namespace cpe
{
std::vector<double> intersection_helper::sphere_ray(const vec3& sphere_center,float sphere_radius,const vec3& ray_center,const vec3& ray_direction)
{
    vec3 x0=ray_center-sphere_center;
    double dx=ray_direction.dot(x0);

    double delta=dx*dx-x0.norm2()+sphere_radius*sphere_radius;
    std::vector<double> inter;

    if(delta<0) //no intersection
        return std::vector<double>();
    else if(delta<1e-5)
    {
        double t=-dx;
        inter.push_back(t);
        return inter;
    }
    else
    {
        double s=std::sqrt(delta);
        double t0=-dx+s;
        double t1=-dx-s;
        inter.push_back(t0);inter.push_back(t1);
        return inter;
    }

}

}
