#include "maFenetre.hpp"
#include "monWidgetGL.hpp"

#include <iostream>

#include "ui_mainwindow.h"

maFenetre::maFenetre(QWidget *parent)
    :QMainWindow(parent),ui(new Ui::MainWindow)
{
    std::cout<<"Generation de la fenetre"<<std::endl;

    ui->setupUi(this);

    std::cout<<"Cree Widget OpenGL"<<std::endl;

    QGLFormat qglFormat;
    qglFormat.setVersion(1,2);
    glWidget=new monWidgetGL(qglFormat);
    ui->layout_scene->addWidget(glWidget);


    connect(ui->quitter,SIGNAL(clicked()),this,SLOT(action_quitter()));
    connect(ui->afficher,SIGNAL(clicked()),this,SLOT(action_afficher()));
    connect(ui->checkBox,SIGNAL(clicked()),this,SLOT(action_wireframe()));

    connect(ui->refresh,SIGNAL(clicked()),this,SLOT(compute()));

}

maFenetre::~maFenetre()
{
    std::cout<<"Destruction fenetre"<<std::endl;
    if(ui!=NULL)
    {
        delete ui;
        ui=NULL;
    }
}

void maFenetre::action_quitter()
{
    close();
}

void maFenetre::action_afficher()
{
    glWidget->afficher();
}

void maFenetre::action_wireframe()
{
    bool etat_wireframe=ui->checkBox->isChecked();
    glWidget->wireframe(etat_wireframe);
}

void maFenetre::compute()
{
    const std::string formula_x=ui->xuv->toPlainText().toStdString();
    const std::string formula_y=ui->yuv->toPlainText().toStdString();
    const std::string formula_z=ui->zuv->toPlainText().toStdString();

    float u_min=ui->u_min->toPlainText().toFloat();
    float u_max=ui->u_max->toPlainText().toFloat();

    float v_min=ui->v_min->toPlainText().toFloat();
    float v_max=ui->v_max->toPlainText().toFloat();

    int Nu=ui->Nu->toPlainText().toInt();
    int Nv=ui->Nv->toPlainText().toInt();

    bool is_inverse=ui->inverse_normal->isChecked();

    glWidget->scene_3d.build_surface(formula_x,formula_y,formula_z,
                        u_min,u_max,
                        v_min,v_max,
                        Nu,Nv,is_inverse);

}
